import nltk
import random
from nltk.corpus import movie_reviews

documents = [(list(movie_reviews.words(fileid)), category)
             for category in movie_reviews.categories()
             for fileid in movie_reviews.fileids(category)]

random.shuffle(documents)

# print(documents[1])

# all words in lowercase
all_words = []
for w in movie_reviews.words():
    all_words.append(w.lower())

# frequency distribution for words
all_words = nltk.FreqDist(all_words)

# print(all_words.most_common(10))
# frequency of occurring word 'stupid' in corpora
# print(all_words["stupid"])

word_features = list(all_words.keys())[:3000]


def find_features(document):
    words = set(document)
    features = {}
    for w in word_features:
        features[w] = (w in words)  # boolean value

    return features


# print(find_features(movie_reviews.words('neg/cv000_29416.txt')))

feature_sets = [(find_features(rev), category)
                for (rev, category) in documents
                ]

training_set = feature_sets[:1900]
testing_set = feature_sets[1900:]

classifier = nltk.NaiveBayesClassifier.train(training_set)
print((nltk.classify.accuracy(classifier, training_set))*100)
classifier.show_most_informative_features(15)
